/**
 * Copyright Qnext Inc. 2002-2017
 * http://www.qnext.com
 * Date: 11.02.2016
 * Time: 12:00
 * Author Iliya Kinanev (iliyak@qnext.com)
 * Author Petar Vanchev (petarv@qnext.com)
 */


/**
 * When TRUE will not redirection to https
 *
 * @type {boolean}
 * @constant
 */
var TEST_LOCALLY = false;
/**
 * Predefined button id
 *
 * @type {string}
 * @constant
 */
var BTN_CANCEL_ID = "btnCancel";
/**
 * Predefined button id
 *
 * @type {string}
 * @constant
 */
var BTN_ACTIVATE_ID = "btnActivate";
/**
 * Predefined button id
 *
 * @type {string}
 * @constant
 */
var BTN_SAVE_ID = "btnSave";

// For error code mapping see http://jira.cnexus.com/browse/FFS-4284

/**
 * Predefined error code
 *
 * @type {number}
 * @constant
 */
var ERROR_OK = 0;
/**
 * Predefined error code
 * #define		ADD_ERROR_USER_VALIDATION		"1001"
 *
 * @type {number}
 * @constant
 */
var ERROR_LOGIN = 1001;
/**
 * "Connection failed" Predefined error code
 * Used string 'error_communication'
 * #define		ADD_ERROR_CONNECTION			"1002"
 *
 * @type {number}
 * @constant
 */
var ERROR_CONNECTION = 1002;
/**
 * "Connection timeout" Predefined error code
 * Used string 'error_communication'
 * #define		ADD_ERROR_NO_RESPONSE			"1003"
 *
 * @type {number}
 * @constant
 */
var ERROR_TIME_OUT = 1003;
/**
 * Predefined error code
 * #define		ADD_ERROR_INVALID_CODE			"1004"
 *
 * @type {number}
 * @constant
 */
var ERROR_INVALID_CODE = 1004;
/**
 * Predefined error code
 * #define		ADD_ERROR_UNKNOWN				"1005"
 *
 * @type {number}
 * @constant
 */
var ERROR_UNKNOWN = 1005;
/**
 * Predefined error code
 * #define		ADD_ERROR_SHUTTING_DOWN			"1006"
 *
 * @type {number}
 * @constant
 */
var PASSIVE_IS_DOWN = 1006;
/**
 * Predefined error code
 * #define		ADD_ERROR_DID_SET				"1007"
 *
 * @type {number}
 * @constant
 */
var SHARE_ID_EXIST = 1007;
/**
 * Error code when call to the portal/lookup server fails when discover MSP.
 * #define		ADD_ERROR_LOOKUP_FAILURE		"1009"
 * See FF-3261.
 * Corresponds to string "error_portal_error".
 *
 * @type {number}
 * @constant
 */
var ERROR_PORTAL = 1009;

/**
 * Error code when there is a SSL certificate issue during communication.
 * #define		ADD_ERROR_SSL_CERTIFICATE_ISSUE		"1012"
 * See FF-7818.
 * Corresponds to string "error_ssl_certificate_issue".
 *
 * @type {number}
 * @constant
 */
var ERROR_SSL_CERTIFICATE_ISSUE = 1012;


/////////////////////////////
// Client ONLY Error IDs

/**
 * Error code when encryption policy options are higher than what is supported on the device.
 *
 * @type {number}
 * @constant
 */
var ERROR_UNSUPPORTED_ENCRYPTION = 4001;

/**
 * Error code when sending of logs failed.
 *
 * @type {number}
 * @constant
 */
var ERROR_SEND_LOGS = 4002;


/**
 * Predefined error code
 *
 * @type {number}
 * @constant
 */
var ERROR_SHARE = 5001;
/**
 * Predefined error code
 *
 * @type {number}
 * @constant
 */
var ERROR_SHARE_FAILED_TO_START = 5002;
/**
 * Predefined error code
 *
 * @type {number}
 * @constant
 */
var ERROR_INTERNAL_SERVER = 5003;
/**
 * Predefined error code
 *
 * @type {number}
 * @constant
 */
var ERROR_JSON_PARSE_FAILED = 5004;
/**
 * Predefined error code
 *
 * @type {number}
 * @constant
 */
var ERROR_AJAX_REQUEST_ABORTED = 5005;

/**
 * Key of Operation OS name/type.
 * Example value for that key in {@link _LIST_GLOBALS}: "Linux" get from StatusInfo
 *
 * @type {String}
 * @constant
 */
var KEY_GLOBAL_DEVICE_OS = "os";
/**
 * Key of global parameter to define locale.
 *
 * @type {String}
 * @constant
 */
var KEY_GLOBAL_LOCALE = "locale";
/**
 * Key of scheme name parsed from URL parameter "scheme".
 * Example value for that key in {@link _LIST_GLOBALS}: "pc" or "synology".
 *
 * @type {String}
 * @constant
 */
var KEY_GLOBAL_DEVICE_SCHEME = "scheme";
/**
 * Key of application type parsed from URL parameter "device" which identify the running client.
 * Value for that key in {@link _LIST_GLOBALS} can be
 * any DEVICE ID returned from server.
 * Example: "ClientNativeIOS", "ClientNativeDesktopEnterprise", "AndroidMobile",
 * "Firefox", etc. See BuilderDescriptor.xml in DD library.
 * See FF-9761.
 *
 * @type {String}
 * @constant
 */
var KEY_GLOBAL_CLIENT_DEVICE = "device";
/**
 * Key of dataguard (SGX) support
 * Value for that key can be "true" or "false"
 *
 * @type {String}
 * @constant
 */
var KEY_GLOBAL_DATAGUARD = "dataguard";
/**
 * Key of encrypt support
 * Value for that key can be "true" or "false"
 *
 * @type {String}
 * @constant
 */
var KEY_GLOBAL_ENCRYPT = "encrypt";
/**
 * Key that tels did machine that passive is running has installed LibreOffice or not
 * Value for that key can be "true" or "false"
 *
 * @type {String}
 * @constant
 */
var KEY_GLOBAL_VIEW_ONLY = "view-only";
/**
 * Key of current passive security
 *
 * @type {String}
 * @constant
 */
var KEY_GLOBAL_DEVICE_SECURITY = "device-security";
/**
 * Key of network browsing enabled returned from passive in status info
 * Value for that key can be "true" or "false"
 *
 * @type {String}
 * @constant
 */
var KEY_GLOBAL_NETWORK_ENABLED = "network-enabled";
/**
 * Key of default domain returned from passive in status info
 *
 * @type {String}
 * @constant
 */
var KEY_GLOBAL_DEFAULT_DOMAIN = "default-domain";
/**
 * Key of host name override returned from passive in status info
 *
 * @type {String}
 * @constant
 */
var KEY_GLOBAL_HOST_OVERRIDE = "host-override";
/**
 * Key of proxy object returned from passive in status info
 * Format is:
 *  {
 *      "detect": true,
 *      "local": false,
 *      "type": "NOTSET",
 *      "server": "",
 *      "port": 8080,
 *      "user": ""
 * }
 *
 * @type {String}
 * @constant
 */
var KEY_GLOBAL_PROXY = "proxy";
/**
 * Key of activation code parsed from URL parameter "code".
 * Value of that key in {@link _LIST_GLOBALS} is optional
 *
 * @type {String}
 * @constant
 */
var KEY_GLOBAL_CODE_ACTIVATE = "code";
/**
 * Key of msp id parsed from URL parameter "mspId".
 * Value of that key in {@link _LIST_GLOBALS} is optional
 *
 * @type {String}
 * @constant
 */
var KEY_GLOBAL_MSP_ID = "mspId";
/**
 * Key of user id parsed from URL parameter "uid".
 *
 * @type {String}
 * @constant
 */
var KEY_GLOBAL_UID = "uid";
/**
 * Key of username parsed from URL parameter "username".
 * Value of that key in {@link _LIST_GLOBALS} is optional
 *
 * @type {String}
 * @constant
 */
var KEY_GLOBAL_USERNAME = "username";
/**
 * Key of domain id parsed from URL parameter "domain".
 * Value of that key in {@link _LIST_GLOBALS} is optional
 *
 * @type {String}
 * @constant
 */
var KEY_GLOBAL_DOMAIN = "domain";
/**
 * Key of meta id parsed from URL parameter "meta".
 * Value of that key in {@link _LIST_GLOBALS} is optional
 *
 * @type {String}
 * @constant
 */
var KEY_GLOBAL_META = "meta";

/**
 * Key of retry link id parsed from URL parameter "retryLink".
 * Value of that key in {@link _LIST_GLOBALS} is optional
 *
 * @type {String}
 * @constant
 */
var KEY_GLOBAL_RETRY_LINK = "retryLink";
/**
 * Key of retry link id parsed from URL parameter "cancelLink".
 * Value of that key in {@link _LIST_GLOBALS} is optional
 *
 * @type {String}
 * @constant
 */
var KEY_GLOBAL_CANCEL_LINK = "cancelLink";

/**
 * Key of list with allowed encryption method passed from the client.
 * Possible values: None, Raw, Sgx
 *
 * @type {String}
 * @constant
 */
var KEY_GLOBAL_LIST_METHOD_ENCRYPT_ALLOW = "enc_allow";
/**
 * Key of parent passive provider security passed from the client.
 * Will be valid only in case when re-auth inherited provider.
 * Possible values: None, Raw, Sgx
 *
 * @type {String}
 * @private
 * @constant
 */
var _KEY_GLOBAL_SECURITY = "sec";

/**
 * Key of provider caps passed from the client.
 * Possible values: for now is just "e"
 *
 * @type {String}
 * @constant
 */
var KEY_GLOBAL_PROV_CAPS = "prov_caps";

/**
 * Key of caps parsed from URL parameter "caps".
 * Value of that key in {@link _LIST_GLOBALS} is optional
 *
 * @type {String}
 * @constant
 */
var KEY_GLOBAL_CAPS = "caps";
/**
 * Key of device id parsed from URL parameter "did"
 *
 * @type {string}
 * @constant
 */
var KEY_GLOBAL_DEVICE_ID = "did";

/**
 * Key of Platform/scheme name.
 * Example value for that key in {@link _LIST_GLOBALS}: "pc" or "synology" get from StatusInfo
 *
 * @type {String}
 * @private
 * @constant
 */
var _KEY_GLOBAL_DEVICE_PLATFORM = "platform";
/**
 * Key of device-id-user/username.
 *
 * @type {String}
 * @private
 * @constant
 */
var _KEY_GLOBAL_DEVICE_ID_USER = "device-id-user";
/**
 * Key of device-id-domain/domain.
 *
 * @type {String}
 * @private
 * @constant
 */
var _KEY_GLOBAL_DEVICE_ID_DOMAIN = "device-id-domain";
/**
 * Key of lookup server url parsed from StatusInfo
 *
 * this is only used for error display
 * @type {String}
 * @constant
 */
var KEY_GLOBAL_LOOKUP_SERVER = "lserver";
/**
 * Key of redirect server url parsed from StatusInfo
 * this is only used for error display
 *
 * @type {String}
 * @constant
 */
var KEY_GLOBAL_REDIRECT_SERVER = "server";
/**
 * Key of currently set list mode parsed from StatusInfo.
 * Default is {@link #LIST_MODE_PC}
 *
 * @type {String}
 * @constant
 */
var KEY_GLOBAL_LIST_MODE_CUR = "list-mode";
/**
 * Key of to enable or not set of list mode parsed from StatusInfo.
 * Default is false.
 * See FF-8275
 *
 * @type {String}
 * @constant
 */
var KEY_GLOBAL_LIST_MODE_DISABLE = "list-lock";

/**
 * List with predefined global keys for URL parameters
 *
 * @type {Array}
 * @private
 * @constant
 */
var _LIST_URL_GLOBAL_KEYS = [
    KEY_GLOBAL_LOCALE,
    KEY_GLOBAL_DEVICE_SCHEME,
    KEY_GLOBAL_CLIENT_DEVICE,
    KEY_GLOBAL_CODE_ACTIVATE,
    KEY_GLOBAL_MSP_ID,
    KEY_GLOBAL_UID,
    KEY_GLOBAL_USERNAME,
    KEY_GLOBAL_DOMAIN,
    KEY_GLOBAL_META,
    KEY_GLOBAL_RETRY_LINK,
    KEY_GLOBAL_CANCEL_LINK,
    KEY_GLOBAL_LIST_METHOD_ENCRYPT_ALLOW,
    _KEY_GLOBAL_SECURITY,
    KEY_GLOBAL_PROV_CAPS,
    KEY_GLOBAL_CAPS,
    KEY_GLOBAL_DEVICE_ID,
    KEY_GLOBAL_DEVICE_SECURITY
];

/**
 * List with predefined global keys StatusInfo parameters
 *
 * @type {Array}
 * @private
 * @constant
 */
var _LIST_STATUS_INFO_GLOBAL_KEYS = [
    KEY_GLOBAL_DEVICE_OS,
    KEY_GLOBAL_DATAGUARD,
    KEY_GLOBAL_ENCRYPT,
    KEY_GLOBAL_VIEW_ONLY,
    KEY_GLOBAL_DEVICE_SECURITY,
    KEY_GLOBAL_DEVICE_SCHEME,
    KEY_GLOBAL_USERNAME,
    KEY_GLOBAL_DOMAIN,
    KEY_GLOBAL_NETWORK_ENABLED,
    KEY_GLOBAL_DEFAULT_DOMAIN,
    KEY_GLOBAL_HOST_OVERRIDE,
    KEY_GLOBAL_PROXY,
    _KEY_GLOBAL_DEVICE_PLATFORM,
    _KEY_GLOBAL_DEVICE_ID_USER,
    _KEY_GLOBAL_DEVICE_ID_DOMAIN,
    KEY_GLOBAL_LOOKUP_SERVER,
    KEY_GLOBAL_REDIRECT_SERVER,
    KEY_GLOBAL_LIST_MODE_CUR,
    KEY_GLOBAL_LIST_MODE_DISABLE
];

/**
 * List with globals. Contains parsed params from URL and from StatusInfo.
 * Do not access is directly instead use {@link #_addGlobal} and {@link #getGlobal}
 *
 * @type {Object}
 * @private
 */
var _LIST_GLOBALS = {};

/**
 * Seconds to wait before redirect
 *
 * @type {number}
 * @private
 * @constant
 */
var _REDIRECT_SECONDS = 3;
/**
 * Secure port number
 *
 * @type {number}
 * @private
 * @constant
 */
var _HTTPS_PORT = 4009;
/**
 * List with predefined resource names.

 * @type {Object}
 * @private
 * @constant
 */
var _LIST_IMAGE = {
    "scrUsername": "scr_username.jpg",
    "scrPassword": "scr_password.jpg",
    "scrDomain": "scr_domain.jpg",

    "scrUsername_windows_pc": "scr_username.jpg",
    "scrPassword_windows_pc": "scr_password.jpg",
    "scrDomain_windows_pc": "scr_domain.jpg",
    "scrUsername_windows_network": "scr_username.jpg",
    "scrPassword_windows_network": "scr_password.jpg",
    "scrDomain_windows_network": "scr_domain.jpg",

    "scrUsername_mac_pc": "scr_username_mac_pc.jpg",
    "scrPassword_mac_pc": "scr_password_mac_pc.jpg",
    "scrDomain_mac_pc": "scr_domain_mac_pc.jpg",

    "scrUsername_linux_pc": "scr_username_linux_pc.jpg",
    "scrPassword_linux_pc": "scr_password_linux_pc.jpg",
    "scrDomain_linux_pc": "scr_domain_linux_pc.jpg",
    "scrUsername_linux_synology": "scr_username_synology.jpg",
    "scrPassword_linux_synology": "scr_password_synology.jpg",
    "scrDomain_linux_synology": "scr_empty.png",
    "scrUsername_linux_qnap": "scr_username_qnap.jpg",
    "scrPassword_linux_qnap": "scr_password_qnap.jpg",
    "scrDomain_linux_qnap": "scr_empty.png",
    "scrUsername_linux_drobo": "scr_username_drobo.jpg",
    "scrPassword_linux_drobo": "scr_password_drobo.jpg",
    "scrDomain_linux_drobo": "scr_empty.png",
    "scrUsername_linux_netgear": "scr_username_netgear.jpg",
    "scrPassword_linux_netgear": "scr_password_netgear.jpg",
    "scrDomain_linux_netgear": "scr_empty.png",
    "scrUsername_linux_overland": "scr_username_overland.jpg",
    "scrPassword_linux_overland": "scr_password_overland.jpg",
    "scrDomain_linux_overland": "scr_empty.png",
    "scrUsername_linux_tplink": "scr_username_tplink.jpg",
    "scrPassword_linux_tplink": "scr_password_tplink.jpg",
    "scrDomain_linux_tplink": "scr_empty.png",
    "scrUsername_linux_asustor": "scr_username_asustor.jpg",
    "scrPassword_linux_asustor": "scr_password_asustor.jpg",
    "scrDomain_linux_asustor": "scr_empty.png",
    "scrUsername_linux_wd": "scr_username_wd.jpg",
    "scrPassword_linux_wd": "scr_password_wd.jpg",
    "scrDomain_linux_wd": "scr_empty.png",
    "scrUsername_linux_asuswrt": "scr_username_asus.jpg",
    "scrPassword_linux_asuswrt": "scr_password_asus.jpg",
    "scrDomain_linux_asuswrt": "scr_empty.png"
};

/**
 * No encryption
 * @type {string}
 */
var ENC_NONE = "None";
/**
 * Raw encryption (no SGX/attestation)
 * @type {string}
 */
var ENC_RAW = "Raw";
/**
 * SGX encryption - both client and passive attestation required
 * @type {string}
 */
var ENC_SGX = "Sgx";
/**
 * Predefined list mode
 *
 * @type {string}
 * @constant
 */
var LIST_MODE_PC = "pc";
/**
 * Predefined list mode
 *
 * @type {string}
 * @constant
 */
var LIST_MODE_SERVER = "server";

// Set Default values, will be used to get expected type in parsing (addGlobal)
_LIST_GLOBALS[KEY_GLOBAL_DEVICE_SCHEME] = "";
_LIST_GLOBALS[KEY_GLOBAL_LOCALE] = ""; // This will be init in QnLocale.initLocale

_LIST_GLOBALS[KEY_GLOBAL_CLIENT_DEVICE] = "Unknown";
_LIST_GLOBALS[KEY_GLOBAL_CODE_ACTIVATE] = "";
_LIST_GLOBALS[KEY_GLOBAL_MSP_ID] = "";
_LIST_GLOBALS[KEY_GLOBAL_UID] = "";
_LIST_GLOBALS[KEY_GLOBAL_USERNAME] = "";
_LIST_GLOBALS[KEY_GLOBAL_DOMAIN] = "";

_LIST_GLOBALS[KEY_GLOBAL_META] = "";
_LIST_GLOBALS[KEY_GLOBAL_RETRY_LINK] = "";
_LIST_GLOBALS[KEY_GLOBAL_CANCEL_LINK] = "";
_LIST_GLOBALS[KEY_GLOBAL_LIST_METHOD_ENCRYPT_ALLOW] = [ENC_NONE];
_LIST_GLOBALS[KEY_GLOBAL_PROV_CAPS] = [];
_LIST_GLOBALS[KEY_GLOBAL_CAPS] = ""; // For now only NoTopToolbar
_LIST_GLOBALS[KEY_GLOBAL_DEVICE_ID] = "";
_LIST_GLOBALS[KEY_GLOBAL_DEVICE_OS] = "";
_LIST_GLOBALS[KEY_GLOBAL_DATAGUARD] = false;
_LIST_GLOBALS[KEY_GLOBAL_ENCRYPT] = false;
_LIST_GLOBALS[KEY_GLOBAL_VIEW_ONLY] = false;
_LIST_GLOBALS[KEY_GLOBAL_DEVICE_SECURITY] = -1;
_LIST_GLOBALS[KEY_GLOBAL_NETWORK_ENABLED] = false;
_LIST_GLOBALS[KEY_GLOBAL_DEFAULT_DOMAIN] = "";
_LIST_GLOBALS[KEY_GLOBAL_HOST_OVERRIDE] = "";
_LIST_GLOBALS[KEY_GLOBAL_PROXY] = ProxyConfig.NOT_SET;
_LIST_GLOBALS[KEY_GLOBAL_LOOKUP_SERVER] = "fileshare.cnexus.com";
_LIST_GLOBALS[KEY_GLOBAL_REDIRECT_SERVER] = "fileshare.cnexus.com";
_LIST_GLOBALS[KEY_GLOBAL_LIST_MODE_CUR] = LIST_MODE_PC;
_LIST_GLOBALS[KEY_GLOBAL_LIST_MODE_DISABLE] = true;


/* Private methods */

/**
 *
 * @param {String} key
 * @return {String} normalized key. Key can be same as original if: 1. not need to be normalized - normal case
 *                                                                  2. not defined for normalization - will trace warning
 * @private
 */
function _normalizeGlobalKey(key) {
    switch (key) {
        case _KEY_GLOBAL_DEVICE_PLATFORM:
            key = KEY_GLOBAL_DEVICE_SCHEME;
            break;
        case _KEY_GLOBAL_DEVICE_ID_USER:
            key = KEY_GLOBAL_USERNAME;
            break;
        case _KEY_GLOBAL_DEVICE_ID_DOMAIN:
            key = KEY_GLOBAL_DOMAIN;
            break;
        case _KEY_GLOBAL_SECURITY:
            key = KEY_GLOBAL_DEVICE_SECURITY;
            break;
        case KEY_GLOBAL_DEVICE_OS:
        case KEY_GLOBAL_DEVICE_SCHEME:
        case KEY_GLOBAL_DATAGUARD:
        case KEY_GLOBAL_ENCRYPT:
        case KEY_GLOBAL_VIEW_ONLY:
        case KEY_GLOBAL_CLIENT_DEVICE:
        case KEY_GLOBAL_CODE_ACTIVATE:
        case KEY_GLOBAL_MSP_ID:
        case KEY_GLOBAL_UID:
        case KEY_GLOBAL_USERNAME:
        case KEY_GLOBAL_DOMAIN:
        case KEY_GLOBAL_META:
        case KEY_GLOBAL_RETRY_LINK:
        case KEY_GLOBAL_CANCEL_LINK:
        case KEY_GLOBAL_LIST_METHOD_ENCRYPT_ALLOW:
        case KEY_GLOBAL_PROV_CAPS:
        case KEY_GLOBAL_CAPS:
        case KEY_GLOBAL_DEVICE_ID:
        case KEY_GLOBAL_LOOKUP_SERVER:
        case KEY_GLOBAL_REDIRECT_SERVER:
            break;
        default:
            if (TEST_LOCALLY)
                log("Not normalized key=" + key, true);
            break;
    }

    return key;
}

/**
 *
 * @param {String} key
 * @param {String|Number|Boolean|Object} val value to be normalized
 * @return {*} normalized value.
 * @private
 */
function _normalizeGlobalValue(key, val) {
    var valDef = _LIST_GLOBALS[key];
    if (QnUtil.isDefined(valDef)) {
        if (QnUtil.isStr(valDef)) {
            if (!QnUtil.isStr(val))
                logWarn("Invalid string: " + key + "=" + val);
            val = QnUtil.isDefined(val) ? "" + val : "";
            switch (key) {
                case KEY_GLOBAL_DEVICE_OS:
                case KEY_GLOBAL_DEVICE_SCHEME:
                case KEY_GLOBAL_LIST_MODE_CUR:
                    val = val.toLowerCase();
                    break;
                default:
                    break;
            }
            switch (key) {
                case KEY_GLOBAL_DEVICE_OS:
                    switch (val) {
                        case "darwin":
                        case "macintosh":
                            val = "mac";
                            break;
                    }
                    break;
            }
        } else if (QnUtil.isBool(valDef)) {
            if (QnUtil.isStr(val)) {
                val = val.toLowerCase() === "true";
            } else if (!QnUtil.isBool(val)) {
                logWarn("Invalid bool: " + key + "=" + val);
                val = valDef;
            }
            // For now we have no other type that String or Boolean, if needed we can add handling too
        } else if (QnUtil.isNumber(valDef)) {
            if (QnUtil.isStr(val)) {
                val = parseFloat(val);
                if (!QnUtil.isDefined(val)) {
                    logWarn("Invalid number: " + key + "=" + val);
                    val = valDef;
                }
            } else if (!QnUtil.isNumber(val)) {
                logWarn("Invalid number: " + key + "=" + val);
                val = valDef;
            }
        } else if (valDef instanceof ProxyConfig) {
            if (key === KEY_GLOBAL_PROXY)
                val = ProxyConfig.fromStatus(val);

            if (false === val instanceof ProxyConfig)
                logWarn("Invalid proxy config: " + val);
        } else if (valDef instanceof Array) {
            val = JSON.parse(val);

            if (false === val instanceof Array)
                logWarn("Not array: " + val);
        }
        else {
            logWarn("Unknown type: " + key + "=" + valDef + " (" + (typeof valDef) + ")");
        }

    } else {
        logWarn("Unknown key global " + key + "=" + val);
    }
    if (isLogDbg())
        logDbg("Get global key: " + key + "=" + val);
    return val;
}

/**
 * Add given val to list with globals if key is found in list with predefined keys
 *
 * @param {String} key must be non empty string
 * @param {*} val
 * @param {boolean} fromStatus
 * @private
 */
function _addGlobal(key, val, fromStatus) {
    if (key) {
        // normalize some keys
        key = _normalizeGlobalKey(key);
        var list = fromStatus ? _LIST_STATUS_INFO_GLOBAL_KEYS : _LIST_URL_GLOBAL_KEYS;
        if (list.indexOf(key) >= 0) {
            val = _normalizeGlobalValue(key, val);
            _LIST_GLOBALS[key] = val;
        } else {
            if (TEST_LOCALLY)
                log("Not allowed key=" + key);
        }
    } else {
        log("Invalid Global key: " + key + "=" + val);
    }
}

/**
 * Parse URL parameters and put it to list with global params {@link #_LIST_GLOBALS}
 */
function _parseParams() {
    var query = window.location.search;
    if (query) {
        // Remove trailing ? symbol
        if (query.indexOf("?") === 0)
            query = query.substring(1);
        var listRaw = query.split('&');
        for (var i = 0; i < listRaw.length; i++) {
            var raw = listRaw[i];
            if (raw) {
                var param = raw.split('=');
                // Allow empty values, so do not check for param[1]'s length
                if (param.length === 2 && param[0]/* && param[1]*/) {
                    _addGlobal(decodeURIComponent(param[0]), decodeURIComponent(param[1]), false);
                } else {
                    log("Invalid parameter: " + raw, true);
                }
            }
        }
    }
}

/**
 * Add some of statusInfo keys like {@link KEY_GLOBAL_DEVICE_OS} to {@link _LIST_GLOBALS}
 *
 * @param {Object} statusInfo
 * @private
 */
function _setStatusInfoAsGlobals(statusInfo) {
    // To test with full encrypt support
    //statusInfo[var KEY_GLOBAL_DATAGUARD] = true;
    //statusInfo[KEY_GLOBAL_VIEW_ONLY] = true;
    jQuery.each(statusInfo, function (key, value) {
        _addGlobal(key, value, true);
    });

    // Hide main header if there is caps parameter with value notoptoolbar
    var caps = getGlobal(KEY_GLOBAL_CAPS);
    if (caps && caps.indexOf("NoTopToolbar") >= 0) {
        $(".headerCont").hide();
    }

    // Add platform class in homepage device logo if there is platform
    var deviceScheme = getGlobal(KEY_GLOBAL_DEVICE_SCHEME);
    if (deviceScheme)
        $(".aliasLogo").addClass(deviceScheme);


    var dataguard = !!getGlobal(KEY_GLOBAL_DATAGUARD);
    $("#encryptHeaderSgx").toggleClass("encryptHeaderSgxOn", dataguard)
        .toggleClass("encryptHeaderSgxOff", !dataguard);

}

/**
 * Callback called from {@link psvFetchStatus} on success
 *
 * @param {Object} statusInfo success response. For format see {@link psvFetchStatus} or StatusCodeCmd.cpp
 * @param {Function} [callback]
 * @private
 */
function _handleStatusSuccess(statusInfo, callback) {

    // Set globals in both cases (http and https) because of http main landing page loading - before activation page.
    // Status is needed there
    _setStatusInfoAsGlobals(statusInfo);

    // don't bother displaying the status if we're not on a secured channel
    if (_isSecured()) {
        // stop 'secureonly' css fields from being hidden
        $('.secureonly').removeClass('secureonly');

        if (!statusInfo.updateable) {
            log("updates are disabled!");
            _showWarningId("updates_disabled_body");
        }

        // call custom callback
        if (!!callback)
            callback(statusInfo); // TODO Petar: check did param statusInfo is needed here and remove it
    } else {
        // if we're not secured, we redirect the user to the secured version of this page
        redirectUserEventually();
    }
}

/**
 * Render the status in terms of a message, and highlighting errors
 *
 * @param {String} msg
 * @private
 */
function _showWarning(msg) {
    var $cont = $("#updatemsg");
    // remove previous errors using jquery - search for alerts? it will do
    $(".alert", $cont).remove();
    // add the error/success message and highlights
    $("<div class='alert alert-warning'>" + msg + "</div>").appendTo($cont);
}

/**
 * Render the status in terms of a message, and highlighting errors
 *
 * @param {String} uidStr string UID to be used to get message
 * @param {Object} [opts] optional options. See below.
 * @param {Object} [opts.listArg] list with arguments. Optional. See {@link #formatMessage} for format.
 * @param {boolean} [opts.noEsc=false] to NOT escape passed arguments (by default they are escaped)
 * @param {boolean} [opts.isSpec=false] true to try to find first string with UID "[uidStr]_[OS]_[SCHEME]".
 * @private
 */
function _showWarningId(uidStr, opts) {
    var $cont = $("#updatemsg");
    // remove previous errors using jquery - search for alerts? it will do
    $(".alert", $cont).remove();
    // add the error/success message and highlights
    $("<div class='alert alert-warning'></div>")
        .setTextById(uidStr, opts)
        .appendTo($cont);
}

/**
 * Check did current protocol is secure (https)
 *
 * @return {boolean} always valid
 * @private
 */
function _isSecured() {
    var proto = document.location.protocol;
    return TEST_LOCALLY ? true : proto === 'https:';
}


/* Public methods */

/**
 * @returns {boolean} true if logging on INFO level is enabled.
 */
function isLogInfo() {
    return true;
}

/**
 * @returns {boolean} true if logging on INFO level is enabled.
 */
function isLogDbg() {
    return false;
}

/**
 *
 * @param {*} text
 * @param {Boolean} [isWarn] default is false
 */
function log(text, isWarn) {
    if (console) {
        if (isWarn === true)
            console.warn(text);
        else
            console.log(text);
    }
}

/**
 * @param {String} text message to be log on debug level
 */
function logDbg(text) {
    if (isLogDbg())
        log(text, false);
}

/**
 * @param {String} text message to be log on info level
 */
function logInfo(text) {
    if (isLogInfo())
        log(text, false);
}

/**
 * @param {String} text message to be log on warning level
 * @param {Error} [exception=undefined] optional exception to be traced
 */
function logWarn(text, exception) {
    log(text, true);
    if (exception)
        log(exception, true);
}


/**
 * Get param from list with global params {@link #_LIST_GLOBALS}
 *
 * @param {String} key global key to be searched for. Must be valid
 * @returns {String|Number|Boolean|Array} can be null if: 1. no such key in {@link #_LIST_GLOBALS}
 *                                   2. key is null or empty
 */
function getGlobal(key) {
    var global = null;
    key = _normalizeGlobalKey(key);
    if (key && _LIST_GLOBALS.hasOwnProperty(key)) {
        global = _LIST_GLOBALS[key];
    }
    return global;
}


/**
 * Check whether the client app where this is running is native.
 * See FF-9761.
 *
 * @returns {boolean} if is native
 */
function _isNativeClient() {
    var device = getGlobal(KEY_GLOBAL_CLIENT_DEVICE);
    return device.indexOf("ClientNative") >= 0;
}



function generateSecuredUrl() {
    var pathname = window.location.pathname;
    var search = window.location.search;
    var hash = window.location.hash;
    var hostname = window.location.hostname;
    var newUrl = "https://" + hostname + ":" + _HTTPS_PORT + pathname + search + hash;
    return newUrl;
}

function redirectUserEventually() {
    var securedUrl = generateSecuredUrl();
    log("eventually redirecting user to " + securedUrl);

    _showWarningId("redirecting_to_secure", {listArg: {"seconds": _REDIRECT_SECONDS}});

    var remainingSeconds = _REDIRECT_SECONDS;
    var intervalId = setInterval(function () {
        remainingSeconds = redirectAtInterval(securedUrl, remainingSeconds, intervalId);
    }, 1000);
}

function redirectAtInterval(url, seconds, intervalId) {
    seconds = seconds - 1;

    log("redirecting to secured url in " + seconds + "s (interval id " + intervalId + ")");
    if (seconds <= 1) {
        log("clearing interval id " + intervalId);
        clearInterval(intervalId);
        log("performing redirection to " + url);
        window.location.replace(url); // don't save this page to history before redirect (FFS-4082)
    }
    _showWarningId("redirecting_to_secure", {listArg: {"seconds": seconds}});
    return seconds;
}

function addParams(url, params) {
    var isFirst = !url.indexOf('?') > -1;
    for (var key in params) {
        if (Object.prototype.hasOwnProperty.call(params, key)) {
            var value = params[key];
            if (isFirst) {
                isFirst = false;
                url += "?";
            } else {
                url += "&";
            }
            var keyEnc = encodeURIComponent(key);
            var valueEnc = encodeURIComponent(value);
            url += keyEnc + "=" + valueEnc;
        }
    }
    return url;
}

/**
 *
 * @param {String} idComp ID of component to which to set string.
 * Same string ID must exist in language files.
 */
function setTextContext(idComp) {
    //log("Set string " + idStr + ": " + str + " to component: " + idComp);
    $("#" + idComp).setTextById(idComp, {isSpec: true});
}

/**
 *
 * @param {String} idComp ID of component to which to set image to.
 * Same image ID must exist in list with allowed images.
 */
function setImageContext(idComp) {
    var idImg = idComp;
    var $comp = $("#" + idComp);

    var deviceOs = getGlobal(KEY_GLOBAL_DEVICE_OS);
    if (deviceOs)
        idImg += "_" + deviceOs;

    var deviceScheme = getGlobal(KEY_GLOBAL_DEVICE_SCHEME);
    if (deviceScheme)
        idImg += "_" + deviceScheme;

    if (_LIST_IMAGE[idImg] === "scr_empty.png") {
        $comp.css("display", "none");
    }

    if (!_LIST_IMAGE[idImg]) {
        log("Missing image " + idImg + ", will use " + idComp);
        idImg = idComp;
    }

    if (!_LIST_IMAGE[idImg]) {
        log("Missing image for component: " + idComp);
        return;
    }
    //log("Set image for component: " + idComp + "=" + idImg);
    $comp.attr("src", "images/" + _LIST_IMAGE[idImg]);
}

/**
 * Get component with given class and context
 *
 * @param {String} compClass  class of component
 * @param {jQuery} [$context] context of component.
 * If null or omitted will used default context (HTML from element)
 * @return {jQuery}
 */
function getComp(compClass, $context) {
    if (!$context || $context.length <= 0)
        $context = $("form");
    return $("." + compClass, $context);
}

/**
 * Change (Add/Remove) bits given by bitsToChange in bitsIn.
 *
 * @param {Number} bitsIn bits to set in.
 * @param {Number} bitsToChange bits to be set.
 * @param {Boolean} value true to add or false to remove the bits
 * @return {Number} new value with set bits.
 */
function changeBits(bitsIn, bitsToChange, value) {
    if (value) {
        // Set bits
        return (bitsIn | bitsToChange)
    } else {
        // Unset bits
        return (bitsIn & ~bitsToChange);
    }
}

/**
 * Get bits
 *
 * isBitsSet(47 (101111), FrameWithForm._SEC_BITS_SGX) -> true
 * isBitsSet(47 (101111), FrameWithForm._SEC_BITS_NO_ENCRYPT_MEDIA) -> true
 * isBitsSet(7 (000111), FrameWithForm._SEC_BITS_NO_ENCRYPT_MEDIA) -> false
 *
 * @param {Number} bitsIn
 * @param {Number} bitsToCheck
 * @return {Boolean} always valid
 */
function isBitsSet(bitsIn, bitsToCheck) {
    return bitsToCheck === (bitsIn & bitsToCheck)
}

/**
 * Get component with given id and context
 *
 * @param {String} compId  id of component
 * @param {jQuery} [$context] context of component.
 * If null or omitted will used default context (HTML from element)
 * @return {jQuery}
 */
function getCompById(compId, $context) {
    if (!$context || $context.length <= 0)
        $context = $("form");
    return $("#" + compId, $context);
}

/**
 * switch tooltips
 *
 * @param {jQuery} [$comp]
 */
function switchTT($comp) {
    if (!($comp instanceof jQuery) || $comp instanceof jQuery && $comp.length <= 0)
        $comp = $(this).parent();
    $("body").find(".tooltipCont").css("display", "none");
    $comp.find(".tooltipCont").css("display", "inline-block");
}

/**
 * Add focus and hover handler to component with given id
 *
 * @param {String} idComp
 * @param {Boolean} [toFocus] force focus of component. Default is false
 * @param {Boolean} [noHover] to not add hover handler. Default is false
 */
function addFocusHandler(idComp, toFocus, noHover) {
    var $comp = $("#" + idComp);
    $comp.focus(switchTT);
    if (toFocus)
        $comp.focus();

    if (!noHover) {
        $comp.hover(switchTT, function () {
            $("body").find(".tooltipCont").css("display", "none");
            $(':focus').focus();
        });
    }
}

/**
 * Render the status in terms of a message, and highlighting errors
 *
 * @param {Number} errorCode
 * @param {string} strId ID of the string. Must be valid
 * @param {jQuery} [$msgCont]
 */
function showMessage(errorCode, strId, $msgCont) {
    var $errorMsgCont = $msgCont && $msgCont.length > 0 ? $msgCont : $("#updatemsgForm");
    // remove previous errors using jquery - search for alerts? it will do
    getComp("alert", $errorMsgCont).remove();

    var $actGr = getComp("user-code-group");
    var $passGr = getComp("user-password-group");
    var $nameGr = getComp("user-name-group");
    var $domainGr = getComp("user-domain-group");
    // remove errors first from all groups
    $actGr.removeClass("has-error");
    $passGr.removeClass("has-error");
    $nameGr.removeClass("has-error");
    $domainGr.removeClass("has-error");

    // add the error/success message and highlights
    if (errorCode !== ERROR_OK) {
        var isShowRetryLink = false;
        switch (errorCode) {
            case ERROR_LOGIN:
                $nameGr.addClass("has-error");
                $passGr.addClass("has-error");
                $domainGr.addClass("has-error");
                break;
            case ERROR_INVALID_CODE:
                isShowRetryLink = true;
                $actGr.addClass("has-error");
                break;
            default:
                break;
        }

		var opts = {
            isSpec: true
        };
        switch (errorCode) {
            case ERROR_TIME_OUT:
            case ERROR_CONNECTION:
                // Milen: See discussions
                // "Why in so general errors KEY_GLOBAL_REDIRECT_SERVER is used" in
                // https://jira2.cnexus.com/browse/FF-8065?focusedCommentId=48762&page=com.atlassian.jira.plugin.system.issuetabpanels:comment-tabpanel#comment-48762
                // Then again this was changed - see https://jira2.cnexus.com/browse/FF-8374
                // I will keep parameter for future usages
                opts["listArg"] = {
                    "hostnameFFWeb": getGlobal(KEY_GLOBAL_REDIRECT_SERVER)
                };
                break;
            case ERROR_PORTAL:
                opts["listArg"] = {
                    "hostnameFFPortal": getGlobal(KEY_GLOBAL_LOOKUP_SERVER)
                };
                break;
        }

        var $error = $("<div class='alert alert-danger'></div>")
            .setTextById(strId, opts);
        $errorMsgCont.prepend($error);

        // See FF-12159 and FF-12152. And old: FFS-4282
        if (isShowRetryLink) {
            var retryLink = getGlobal(KEY_GLOBAL_RETRY_LINK);
            if (retryLink) {
                $("<a class='retryLink'></a>")
                    .attr("href", retryLink)
                    .setTextById("retry_link")
                    .appendTo($error);
            }
        }
    } else {
        var $comp = $("<div class='alert alert-success'></div>")
                .setTextById(strId);
        $errorMsgCont.prepend($comp);
    }

    if (QnUtil.isDefined(errorCode)) {
        $errorMsgCont.data("error-code", errorCode);
    } else {
        $errorMsgCont.removeData()
    }
}

/**
 * Clear message by given error code
 *
 * @param {String|Number} errorCode
 * @param {jQuery} [$msgCont] message container. Default is $(#updatemsgForm)
 */
function clearMessage(errorCode, $msgCont) {
    $msgCont = $msgCont && $msgCont.length > 0 ? $msgCont : $("#updatemsgForm");

    if ($msgCont.data("error-code") === errorCode)
        $msgCont.html("");
}

/**
 *
 * @param xhr
 * @param err
 * @return {number}
 */
function getError(xhr, err) {
    if (xhr.status === 0) {
        return ERROR_CONNECTION;
    } else if (xhr.status > 300) {
        return ERROR_INTERNAL_SERVER;
    } else if (err === 'parsererror') {
        return ERROR_JSON_PARSE_FAILED;
    } else if (err === 'timeout') {
        return ERROR_TIME_OUT;
    } else if (err === 'abort') {
        return ERROR_AJAX_REQUEST_ABORTED;
    } else {
        return ERROR_UNKNOWN;
    }
}

/**
 * Parse response error message to error code
 *
 * @param {String} msg
 * @return {String}
 */
function translateMsgToErrorCode(msg) {
    var code;
    switch (msg) {
        case "Share failed to start":
            code = ERROR_SHARE_FAILED_TO_START;
            break;
        case "User validation failed":
            code = ERROR_LOGIN;
            break;
        case "Share not found":
            code = ERROR_SHARE;
            break;
        default:
            code = ERROR_UNKNOWN;
            break;
    }

    return code;
}

/**
 * Parse error code to correct error string id
 *
 * @param {Number} [code]
 * @param {jQuery} [$msgCont]
 */
function translateErrorCode(code, $msgCont) {
    var strId;
    switch (code) {
        case ERROR_OK:
            strId = "activate_error_ok";
            break;
        case ERROR_LOGIN:
            strId = "error_invalid_credentials"; // failure - the credentials
            break;
        case ERROR_CONNECTION:
        case ERROR_TIME_OUT: // server HTTP connections timeout, etc
            strId = "error_communication";
            break;
        case ERROR_INVALID_CODE: // any code-related problem
            strId = "error_invalid_code";
            break;
        case ERROR_INTERNAL_SERVER:
            strId = "error_internal_server";
            break;
        case ERROR_JSON_PARSE_FAILED:
            strId = "error_json_parse_failed";
            break;
        case ERROR_AJAX_REQUEST_ABORTED:
            strId = "error_ajax_request_aborted";
            break;
        case ERROR_SHARE:
            strId = "error_invalid_share"; // failure - the share
            break;
        case ERROR_SHARE_FAILED_TO_START:
            strId = "error_share_failed_to_start"; // fail to start - the share
            break;
        case PASSIVE_IS_DOWN:
        case SHARE_ID_EXIST:
            strId = "error_unknown_exception";
            break;
        case ERROR_UNSUPPORTED_ENCRYPTION:
            strId = "error_invalid_encryption_configuration";
            break;
        case ERROR_PORTAL:
            strId = "error_portal";
            break;
        case ERROR_SSL_CERTIFICATE_ISSUE:
            strId = "error_ssl_certificate_issue";
            break;
        default:
            code = ERROR_UNKNOWN;
            strId = "error_unknown_exception"; // unknown failure - assume the code
            break;
    }

    if (strId)
        showMessage(code, strId, $msgCont); // unknown failure - assume the code
}

/**
 * Handles click of the main Cancel button which suppose to return back to the main application
 */
function onReturnToApp() {
    var isNative = _isNativeClient();
    log("Cancel is requested isNative=" + isNative);
    if (isNative) {
        window.open("qnext://client/_SWITCH_TO_MAIN", "_top");
    } else {
        history.back();
    }
}

/**
 * Toggle button by given id depend on {@link #_isNativeClient} in {@link _LIST_GLOBALS}.
 *
 * @param {String} buttonId
 */
function toggleButton(buttonId) {
    var $btnComp = $("#" + buttonId);

    if (_isNativeClient()) {
        $btnComp.css("display", "inline-block");
    } else {
        $btnComp.hide();
    }
}

/**
 * function to fetch the status of the device
 * returns status info as JSON to the onSuccess function, in the format of:
 *{
 *    "build": "$Rev: 80833 $",
 *    "connected": false,
 *    "dataguard": false,
 *    "debug": false,
 *    "default-domain": "",
 *    "device-id-user": "testUser",
 *    "device-id-domain": "testDomain",
 *    "device-security": 47,
 *    "encrypt": true,
 *    "host-override": "",
 *    "jpeg-thumbnails": false,
 *    "network-browsing": true,
 *    "network-enabled": true,
 *    "os": "Windows",
 *    "pki": "<not set>",
 *    "platform": "PC",
 *    "proxy": {
 *          "detect": true,
 *          "type": "NOTSET",
 *          "server": "",
 *          "port": 8080,
 *          "user": ""
 *    }
 *    "resources": [
 *        {
 *            "name": "C: ()",
 *            "capacity": 322016636928,
 *            "available": 189176426496,
 *            "free": 189176426496
 *        },
 *        {
 *            "name": "D: (data)",
 *            "capacity": 678079492096,
 *            "available": 516729012224,
 *            "free": 516729012224
 *        },
 *        {
 *            "name": "E: (Local Disk)",
 *            "capacity": 18446744073709551615,
 *            "available": 18446744073709551615,
 *            "free": 18446744073709551615
 *        }
 *    ],
 *    "revision-space-available": 190015451136,
 *    "revision-space-capacity": 322016636928,
 *    "revision-space-free": 190015451136,
 *    "server": "petarv-pc.cnexusdev.com",
 *    "thumbnails": false,
 *    "updateable": true,
 *    "version": "3.4.18",
 *    "view-only": false
 *}
 *
 * @param {Function} [callback] call on success only if {@link _isSecured} is true
 * @param {Object} [options] request params
 * @param {String} [url] request url
 * @final
 */
function psvFetchStatus(callback, options, url) {
    if (TEST_LOCALLY) {
        // TODO Petar: update test status
        setTimeout(function () {
            var status = {
                "version": "2.1.45",
                "build": "$Rev: 80833 $",
                "updateable": false,
                "debug": false,
                "os": "Linux",
                "platform": "Synology"
            };
            _handleStatusSuccess(status, callback);
        }, 1000);
    } else {
        var data = {
            "cmd": "status",
            "admin": "",
            "password": "",
            "user": ""
        };

        var did = getGlobal(KEY_GLOBAL_DEVICE_ID);
        if (did)
            data["device-id"] = did;

        data = jQuery.extend(data, options);


        var jqXHR = $.ajax({
            method: "GET",
            url: url ? url : "/",
            data: data,
            dataType: "json"
        });

        // noinspection JSUnresolvedFunction
        jqXHR.done(function (resp) {
            // For tests
            // resp[KEY_GLOBAL_LIST_MODE_CUR] = LIST_MODE_SERVER;
            // resp[KEY_GLOBAL_LIST_MODE_DISABLE] = true;
            log("fetchStatus success with: ");
            log(resp);
            _handleStatusSuccess(resp, callback);
        }).fail(function (jqXHR, textStatus, ex) {
            log("fetchStatus failure status: " + jqXHR.status + " " + textStatus +
                (jqXHR.responseText ? ", response: " + jqXHR.responseText : "") +
                (ex ? ", exception: " + ex : ""));
        });
    }
}

// function psvRequest(options, callback, url, method) {
//     var jqXHR = $.ajax({
//         method: method ? method : "GET",
//         url: url ? url : "/",
//         data: options,
//         dataType: "json"
//     });
//
//     // noinspection JSUnresolvedFunction
//     jqXHR.done(function (resp) {
//         log("fetchStatus success with: ");
//         log(resp);
//         _handleStatusSuccess(resp, callback);
//     }).fail(function (jqXHR, textStatus, ex) {
//         log("fetchStatus failure status: " + jqXHR.status + " " + textStatus +
//             (jqXHR.responseText ? ", response: " + jqXHR.responseText : "") +
//             (ex ? ", exception: " + ex : ""));
//     });
// }

_parseParams();
